#!/usr/bin/python
#
# tksaku.py - shinGETsu clone with Tk interface.
# Copyright (c) 2005 shinGETsu Project.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: tksaku.pyw,v 1.5 2005/05/15 03:03:47 fuktommy Exp $
#

import os
import sys
from Tkinter import *
from ScrolledText import ScrolledText

import shingetsu.daemon as daemon
import shingetsu.config as config

__version__ = "$Revision: 1.5 $"

class Sakutk(Frame):
    def createWidgets(self):
        self.master.title(u"SAKU/Tk")

        self.TOP = Frame(self)
        self.TOP.pack(side="top")

        self.LABEL = Label(self.TOP, text=u"SAKU/Tk")
        self.LABEL.pack(side="left")

        self.STOP = Button(self.TOP, text="STOP", command=sys.exit)
        self.STOP.pack(side="right")

        self.TEXT = ScrolledText(self, width=80, height=25, state=DISABLED)
        self.TEXT.pack(expand=True, fill=BOTH)

    def __init__(self, master=None):
        Frame.__init__(self, master)
        self.pack(expand=True, fill=BOTH)
        self.createWidgets()

class Logger(daemon.Logger):

    """Save logs to /LOGDIR/%Y-%m-%d and output Tk textarea."""

    def __init__(self, logdir, textarea):
        daemon.Logger.__init__(self, logdir)
        self.textarea = textarea
        self.linesize = 0

    def write(self, msg):
        daemon.Logger.write(self, msg)
        self.linesize += 1
        self.textarea.config(state=NORMAL)
        while config.tklog < self.linesize:
            self.linesize -= 1
            self.textarea.delete("1.0", "2.0")
        try:
            self.textarea.insert(END, unicode(msg, "utf-8"))
        except UnicodeError:
            pass
        self.textarea.config(state=DISABLED)
        self.textarea.yview(END)

    def flush(self):
        pass

    def close(self):
        self.output.close()

def set_logger(textarea):
    logger = Logger(os.path.join(os.getcwd(), config.log_dir), textarea)
    sys.stderr = logger
    sys.stdout = logger

def main():
    try:
        daemon.setup()
        app = Sakutk()
        set_logger(app.TEXT)
        daemon.start_daemon()
        app.mainloop()
    except KeyboardInterrupt:
        sys.exit()

if __name__ == "__main__":
    main()
